Subject: Re: RE: 1.5.21: Problems with fifos
From: Holger Kiehl <[email-masked]>
To: Dave Korn <[email-masked]>
Cc: [email-masked]
Date: Sat, 16 Sep 2006 11:02:01 +0000 (GMT)

On Tue, 5 Sep 2006, Dave Korn wrote:

> On 05 September 2006 09:39, Holger Kiehl wrote:
>
>>
>> Attached I have the cygcheck.out file. Please tell me if I forget to mention
>> any information that could be usefull or what I can do to solve this.
>
>  The single most valuable thing you could do would be try and extract a
> simple testcase that demonstrates the problem.  AFD is a huge project and
> there may be many confounding factors; if you can write a little
> self-contained program that opens and uses fifos in the same fashion as AFD
> and shows the same effects, the problem would be a lot more tractable.
>
I have managed to write a little test program that shows that the fifos
do not work as I expected it. The attached program can be compiled simply
by 'cc fifot.c'. When called without any argument it opens the fifo fifot.fifo
and does a select on it to wait for some data to arrive. When called with
an argument it opens the fifo for writting and writes "Hallo Ballo!".

Calling this program under cygwin as follows:

    ./a.exe 1

will cause it to block. Under linux it does not block and I would expect under
any other unix like system it will not block either (which I have not tested).

My understanding of fifos was that when I open a fifo for both reading and
writting, I could write to a fifo without it blocking.

Is cygwin handling fifos correct here and my understanding wrong?

Regards,
Holger

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/